local assets=
{
	Asset("ANIM", "anim/goldenspear.zip"),
	Asset("ANIM", "anim/gold_spear.zip"),
    Asset("ATLAS", "images/inventoryimages/goldenspear.xml"),
}

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "gold_spear", "swap_spear")
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

--攻击特效
local function onattack_glodenspear(inst, attacker, target)

    local current_health = target.replica.health:GetCurrent()
	local last_health = attacker.components.health:GetPercent()
	local special_damage = 0.05*current_health 
    if 	current_health > 10 then 
	    if special_damage < 500 then 
	        target.components.health:DoDelta(-special_damage)
	    else
            target.components.health:DoDelta(-500)
	    end
    end
	
	if target:HasTag("largecreature") and last_health < 0.2 then
	   attacker.components.health:DoDelta(10)
    end
end
 

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("spear")
    anim:SetBuild("Goldenspear")
    anim:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    inst:AddComponent("weapon")
 
    inst.components.weapon:SetDamage(TUNING.GOLDENSPEAR_DAMAGE)
	inst.components.weapon:SetOnAttack(onattack_glodenspear)
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.GOLDENSPEAR_USES)
    inst.components.finiteuses:SetUses(TUNING.GOLDENSPEAR_USES)
    
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/goldenspear.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end

return Prefab( "common/inventory/goldenspear", fn, assets) 
